Package: CexoR
Version: 1.48.0
Date: 2025-07-22
Type: Package
Title: An R package to uncover high-resolution protein-DNA interactions
        in ChIP-exo replicates
Authors@R: 
    c(person(given = "Pedro",
           family = "Madrigal",
           role = c("aut", "cre"),
           email = "pmadrigal@ebi.ac.uk",
           comment = c(ORCID = "0000-0003-1959-8199")
      )
    )
Description: Strand specific peak-pair calling in ChIP-exo replicates.
        The cumulative Skellam distribution function
        is used to detect significant normalised count
        differences of opposed sign at each DNA strand (peak-pairs).
        Then, irreproducible discovery rate for overlapping peak-pairs across
        biological replicates is computed.
Depends: R (>= 4.2.0), S4Vectors, IRanges
Imports: Rsamtools, Seqinfo, GenomicRanges, rtracklayer, idr,
        RColorBrewer, genomation
Suggests: RUnit, BiocGenerics, BiocStyle, knitr, rmarkdown
License: Artistic-2.0 | GPL-2 + file LICENSE
biocViews: FunctionalGenomics, Sequencing, Coverage, ChIPSeq,
        PeakDetection
URL: https://github.com/pmb59/CexoR
BugReports: https://github.com/pmb59/CexoR/issues
git_url: https://git.bioconductor.org/packages/CexoR
git_branch: RELEASE_3_22
git_last_commit: 2ba0990
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:04:12 UTC; biocbuild
Author: Pedro Madrigal [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-1959-8199>)
Maintainer: Pedro Madrigal <pmadrigal@ebi.ac.uk>

# CexoR

[![Anaconda-Server Badge](https://anaconda.org/bioconda/bioconductor-cexor/badges/downloads.svg)](https://anaconda.org/bioconda/bioconductor-cexor)
[![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat)](http://bioconda.github.io/recipes/bioconductor-cexor/README.html)
[![DOI:10.14806/ej.21.0.837](https://zenodo.org/badge/DOI/10.14806/ej.21.0.837.svg)](https://doi.org/10.14806/ej.21.0.837)

#--------------------------------------------------------------------------
# pskellam.R and pskellam.sp.R within directory R/ are under GPL(≥2) license
#--------------------------------------------------------------------------
#    skellam: Skellam distribution. 
#
#    Copyright (C) 2009  Jerry W. Lewis
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.



pskellam <- function(q, lambda1, lambda2=lambda1, lower.tail=TRUE, log.p=FALSE){
    # CDF of Skellam distriubition (difference of Poissons)
    if (missing(q)|missing(lambda1)) stop("first 2 arguments are required")
    lambdas <- c(lambda1,lambda2)
    oops <- !(is.finite(lambdas)&(lambdas>=0))
    if(any(oops)) {
        warning("NaNs produced")
        lambdas[oops] <- NaN
        lambda1 <- lambdas[1:length(lambda1)]
        lambda2 <- lambdas[(length(lambda1)+1):length(lambdas)]
    }
    # CDF is a step function, so convert to integer values without warning
    x <- floor(q)
    # make all args the same length (for subsetting)
    lens <- c(length(x),length(lambda1),length(lambda2))
    len <- max(lens)
    if(len>min(lens)) {
        if (all(len/lens!=len%/%lens)) warning("longer object length is not a multiple of shorter object length", domain=NA)
        x <- rep(x,length.out=len)
        lambda1 <- rep(lambda1,length.out=len)
        lambda2 <- rep(lambda2,length.out=len)
    }
    # different formulas for negative & nonnegative x (zero lambda is OK)
    neg <- (x< 0)&(!is.nan(lambda1))&(!is.nan(lambda2))
    pos <- (x>=0)&(!is.nan(lambda1))&(!is.nan(lambda2))
    ret <- rep(NaN,length.out=len)
    if (lower.tail[1]) {
        ret[neg] <- pchisq(2*lambda2[neg],-2*x[neg],2*lambda1[neg],log.p=log.p)
        ret[pos] <- pchisq(2*lambda1[pos],2*(x[pos]+1),2*lambda2[pos],lower.tail=FALSE,log.p=log.p)     # S-PLUS does not have a lower.tail argument
    } else {
        ret[neg] <- pchisq(2*lambda2[neg],-2*x[neg],2*lambda1[neg],lower.tail=FALSE,log.p=log.p)        # S-PLUS does not have a lower.tail argument
        ret[pos] <- pchisq(2*lambda1[pos],2*(x[pos]+1),2*lambda2[pos],log.p=log.p)
    }
    chk <- (neg|pos) & (!is.finite(ret) | (!log.p)&(ret<1e-308))    # use saddlepoint approximation if outside the working range of pchisq
    if (length(chk[chk])>0) ret[chk] <- pskellam.sp(x[chk],lambda1[chk],lambda2[chk],lower.tail,log.p)
    ret
}

cexor <- function( bam, chrN, chrL, p=1e-9, dpeaks=c(0,150), dpairs=100, idr=0.01, N=5e6, bedfile=TRUE, mu=2.6, sigma=1.3, rho=0.8, prop=0.7 )
{
  options(digits=10)

  # Number of treatment samples
  NT <- length(bam)
  # Check chr length and chr names
  LL <- length(chrL)
  #LN <- length(chrN)

  # Read treatment M samples in BAM format (M biological replicates)
  listLen <- 0
  SampleCovPlus <- list()
  SampleCovMinus <- list()
  sumCovPlusMinus <- c()
  totalSum <- c()

  # Read BAM files
  for (j in seq(from=1, to=NT, by=1) ){

      for (i in 1:LL){
              listLen <-  listLen + 1
              which <- GRanges(seqnames = chrN[i], ranges = IRanges(c(1), c(chrL[i])))

              what <- c("rname", "strand", "pos", "qwidth","seq")
              param <- ScanBamParam(which = which, what = what)
              SampleBam <- scanBam(file=bam[j], param=param)
              sapply(SampleBam[[1]], class);

              # + strand
              SamplelstPlus <- lapply(names(SampleBam[[1]]), function(elt) { do.call(c, unname(lapply(SampleBam, "[[", elt)))})
              names(SamplelstPlus) <- names(SampleBam[[1]])
              SampledfPlus <- do.call("DataFrame", SamplelstPlus)
              # correction for reverse strands
              SampledfPlus$pos[which(SampledfPlus$strand=='+')] <- SampledfPlus$pos[which(SampledfPlus$strand=='+')] - 1
              # Modify read length (exonuclease stop sites, 1bp)
              SampledfPlus$qwidth <- 1
              # strand selection
              SampledfPlus <- SampledfPlus[which(SampledfPlus$strand=='+'),]
              SampleCovPlus[[listLen]]  <- coverage(IRanges(SampledfPlus[["pos"]], width = SampledfPlus[["qwidth"]]))
              if (length(SampleCovPlus[[listLen]])   < chrL[i] ) { SampleCovPlus[[listLen]]   <- c(SampleCovPlus[[listLen]],rep(0,chrL[i] - length(SampleCovPlus[[listLen]]) ) )  }
              if (length(SampleCovPlus[[listLen]])   > chrL[i] ) { SampleCovPlus[[listLen]]   <-  SampleCovPlus[[listLen]][1:chrL[i]]     }

              # - strand
              rm(SampledfPlus,SamplelstPlus)
              SamplelstMinus <- lapply(names(SampleBam[[1]]), function(elt) { do.call(c, unname(lapply(SampleBam, "[[", elt)))})
              names(SamplelstMinus) <- names(SampleBam[[1]])
              SampledfMinus  <- do.call("DataFrame", SamplelstMinus )
              # correction for reverse strands
              SampledfMinus$pos[which(SampledfMinus$strand=='-')] <- SampledfMinus$pos[which(SampledfMinus$strand=='-')] -1 + SampledfMinus$qwidth[which(SampledfMinus$strand=='-')]
              # Modify read length  (exonuclease stop sites, 1bp)
              SampledfMinus$qwidth <- 1
              # strand selection
              SampledfMinus <- SampledfMinus[which(SampledfMinus$strand=='-'),]
              SampleCovMinus[[listLen]]  <- coverage(IRanges(SampledfMinus[["pos"]], width = SampledfMinus[["qwidth"]]))
              if (length(SampleCovMinus[[listLen]])   < chrL[i] ) { SampleCovMinus[[listLen]]   <- c(SampleCovMinus[[listLen]],rep(0,chrL[i] - length(SampleCovMinus[[listLen]]) ) )  }
              if (length(SampleCovMinus[[listLen]])   > chrL[i] ) { SampleCovMinus[[listLen]]   <-  SampleCovMinus[[listLen]][1:chrL[i]]     }

             # All reads are considered (information from both strands is taken into account)

              sumCovPlusMinus[listLen]  <- sum(SampleCovPlus[[listLen]])  +  sum(SampleCovMinus[[listLen]])

              rm(SampleBam,SamplelstMinus,SampledfMinus,param,what,which)
      }

      # get total lambda exonuclease cuts at each sample
      totalSum[j] <- sum(sumCovPlusMinus[(((j-1)*LL) + 1):(j*LL)])
  }

 rm(i,j)
 rm(sumCovPlusMinus)
 
 
 # Normalization
 # To the smallest sample  - to make the samples 'comparable'
 # and estimation of Skellam Lambda1 and Lambda2 for each sample
 listLen <- 0
 meanCovPlus <- c()
 meanCovMinus <- c()
 lambda1 <- c()
 lambda2 <- c()

 factorNorm <-  min(totalSum) / totalSum

 for (j in 1:NT){

      for (i in 1:LL){
              listLen <-  listLen + 1
              SampleCovPlus[[listLen]]   <- round( factorNorm[j] * SampleCovPlus[[listLen]]   )      # it is an approximation
              SampleCovMinus[[listLen]]  <- round( factorNorm[j] * SampleCovMinus[[listLen]]  )      # it is an approximation
              meanCovPlus[listLen]  <- mean(SampleCovPlus[[listLen]])
              meanCovMinus[listLen] <- mean(SampleCovMinus[[listLen]])
      }
      # estimating Poisson means of the distributions
      lambda1_ini <- sum((chrL/sum(chrL))  * meanCovPlus[(((j-1)*LL) + 1):(j*LL)])
      lambda2_ini <- sum((chrL/sum(chrL))  * meanCovMinus[(((j-1)*LL) + 1):(j*LL)])

      # lambda1 > lambda2
      lambda1[j] <- max(lambda1_ini,lambda2_ini)
      lambda2[j] <- min(lambda1_ini,lambda2_ini)

      rm(lambda1_ini, lambda2_ini)

   }


  # Get paired peaks at each sample
  # using the Skellam cumulative distribution function
  pairedPeaks  <- list()
  listLen <- 0
  chrLwithPeaks <- list()

  for (w in 1:NT){
      	chrLwithPeaksCount <- 0        
      	filteredScoreFinalChr  <- data.frame()

  		for (i in 1:LL){  
      		filteredScoreFinal     <- data.frame() 
      		listLen <-  listLen + 1
      		mL <- max(length(SampleCovPlus[[listLen]]), length(SampleCovMinus[[listLen]]))
      		#print(LL)
      		#print(mL)
      		#frames <- floor(mL / N) +1 
      		frames <- floor(mL / N) #+1 ###NEW
      		#print(frames)
      		for (m in 1:frames){

         		if (m != frames){
            		lFrame <-  (((m-1)*N)+1):(m*N)
         		}
         		if (m == frames){
            		lFrame<- (((m-1)*N)+1):mL   
         		}
         	#print(m)
         	#print(lFrame)	
            	sample_forward <- as.integer(SampleCovPlus[[listLen]] [  lFrame ])
            	sample_reverse <- as.integer(SampleCovMinus[[listLen]][  lFrame ])

         		# Difference of exonuclease start sites at each strand
         		k <- as.integer(sample_forward - sample_reverse)

         		rm(sample_forward,sample_reverse)

         		# Skellam cumulative distribution function
         		# Calculate p-value (two-sided test)
         		score <- c()
         		iPlus  <- which(k>=0)   # '='can be at both
         		iMinus <- which(k<0)
         		score[iPlus]  <- pskellam(q=k[iPlus],    lambda1= lambda1[w], lambda2 = lambda2[w], lower.tail = FALSE, log.p = FALSE)
         		score[iMinus] <- pskellam(q=k[iMinus]-1, lambda1= lambda1[w], lambda2 = lambda2[w], lower.tail = TRUE, log.p = FALSE)

         		# p-value threshold
         		positions <- which(score <= p)   # score has peak p-values, F(x)

         		# which ones are close to each other
         		maxD <-  dpeaks[2]  #150 #30
         		minD <-  dpeaks[1]  #0   #8

         		filteredScore <- data.frame()
         		idx <- 0

         		if (length(positions)>1){
              		# keep just Max and Min in a region of length dpeaks[2]+1
              		W <- dpeaks[2]+1   #151
              		new_positions <- c()
              		for (ww in 1:length(positions)){
                		if ( positions[ww]-W < ceiling( W)  ){  vectorAux <- k[1:(positions[ww]+W) ]  }
                   		if ( positions[ww]-W >= ceiling( W)  &  positions[ww]+W <= N-floor(W)  ){  vectorAux <- k[(positions[ww]-W):(positions[ww]+W) ]  }
                   		if ( positions[ww]+W > N-floor(W)  ){  vectorAux <- k[(positions[ww]-W):N ]  }
                   		maximo <- max(vectorAux)
                   		minimo <- min(vectorAux)
  #               		print(ww)
  #                 		print(maximo)
  #                 		print(minimo)
                   		if( k[positions[ww]]==maximo && maximo >0 ){ new_positions <- c( new_positions,positions[ww]) }
                   		if( k[positions[ww]]==minimo && minimo <0 ){ new_positions <- c( new_positions,positions[ww]) }
              	}
        		positions <- new_positions
        		rm(new_positions)
   				if (length(positions) >= 2){ #######################NEW
        			for (j in 2:length(positions)){
                		A <- positions[j-1]
	                	B <- positions[j]
	                	C <- sign(k[positions[j-1]])
	                	D <- sign(k[positions[j]])
	                	# region for max and min
                		if (C != 0  && D != 0 ){
	             			if (B< A+maxD && B> A+minD  && (C == 1  && D== -1 || C== -1  && D == 1)  ){
		            			idx=idx+1
		                   		filteredScore[idx,1] <- chrN[i]
		                   		filteredScore[idx,2] <- round((lFrame[positions[j-1]] + lFrame[positions[j]])/2) -dpairs
		                   		filteredScore[idx,3] <- round((lFrame[positions[j-1]] + lFrame[positions[j]])/2) +dpairs
		                   		filteredScore[idx,4] <- lFrame[positions[j]]-lFrame[positions[j-1]]
		                   		filteredScore[idx,5] <- signif(score[positions[j-1]], digits=30)
		                   		filteredScore[idx,6] <- signif(score[positions[j]] , digits=30)
				           	pvalVector <- c(score[positions[j-1]] , score[positions[j]])
				   		filteredScore[idx,7] <- sum(pvalVector)  #pchisq(-2*sum(log(pvalVector)), df=2*length(pvalVector), lower=FALSE )
			           	   	filteredScore[idx,8] <- -1*log10(filteredScore[idx,7])
			        		}
		        	 	}
        	 		}
 				}########################NEW             
 		}

		if ( length(filteredScoreFinal) ==0  &&  length(filteredScore) > 0) { filteredScoreFinal <- filteredScore  }
                   
			if ( length(filteredScoreFinal) > 0 &&  length(filteredScore) > 0) { filteredScoreFinal <- rbind(filteredScoreFinal,filteredScore)}

    }     #end frame
    
    

   if ( length(filteredScoreFinal) > 0  ){                                                
        if (length(filteredScoreFinalChr) ==0 ) {  filteredScoreFinalChr <- filteredScoreFinal   }
    	if (length(filteredScoreFinalChr) > 0 ) {  filteredScoreFinalChr <- rbind(filteredScoreFinalChr, filteredScoreFinal )  }
        #save the chromosome
        chrLwithPeaksCount <- chrLwithPeaksCount + 1                                        
        if(chrLwithPeaksCount == 1) { chrLwithPeaks[[w]] <- chrL[i]  }                      
        if(chrLwithPeaksCount > 1)  { chrLwithPeaks[[w]][chrLwithPeaksCount] <- chrL[i]  }  
	}                                                                                      
}         #end chromosome
                                     

 colnames(filteredScoreFinalChr) <- c("chr","start","end","length","pval.peak.forward","pval.peak.reverse", "pval.binding.event","log10.pval.binding.event")
 pairedPeaks[[w]] <- filteredScoreFinalChr

 rm(filteredScoreFinalChr)
}

#print(head(filteredScoreFinalChr))



##############################################################################

#create a GRanges structure for each biol. replicate
repl <- list()

for (w in 1:NT){

      repl[[w]] <- GRanges(seqnames=pairedPeaks[[w]]$chr,
                  ranges=IRanges(pairedPeaks[[w]]$start, end=pairedPeaks[[w]]$end),
                  score=pairedPeaks[[w]]$log10.pval.binding.event)

       seqlengths(repl[[w]])   <- chrLwithPeaks[[w]]    ##chrL
       
       repl[[w]] <- trim(repl[[w]], use.names=TRUE)
}


# (intersect) final list of chip-exo peaks
finalset  <- repl[[1]]

for (w in 2:NT){
         finalsetini <-  finalset
         finalset <- intersect(repl[[w]],finalsetini )

}

       finalset <- trim(finalset, use.names=TRUE)
       

# prepare matrix MM for IDR assessment
MM <- matrix(data = NA, nrow = length(finalset), ncol = NT)

for (w in 1:NT){
    for (i in 1: length(finalset) ){
      MM[i,w] <-   max(score( subsetByOverlaps(repl[[w]],finalset[i]) ))   #MIN is very conservative
    }
}

# send matrix MM to IDR analysis
#  mu <- 2.6
#  sigma <- 1.3
#  rho <- 0.8
#  p <- 0.7

 # library(idr)
 # x = a m by n numeric matrix, where m= num of replicates, n=num of observations. Numerical values representing the significance
 # of the observations, where signals are expected to have large values, for example, -log(p-value).
 idr.out <- est.IDR(x=MM, mu, sigma, rho, prop, eps=0.00001)
 #idr.out$IDR

# FINAL  sites
# values(finalset) <- idr.out$IDR
 passingIDR <- which(idr.out$IDR< idr)

# prepare final GRanges
PVALMATRIX=10^-MM

MM2 <- as.data.frame(MM)
colnames(MM2) <- paste(paste("rep", as.character(1:NT), sep=""), "neg.log10pvalue",sep=".")
# get p-values



#http://en.wikipedia.org/wiki/Fisher%27s_method
Stouffer.test <- function(p, w) { # p is a vector of p-values
  if (missing(w)) {
    w <- rep(1, length(p))/length(p)
  } else {
    if (length(w) != length(p))
      stop("Length of p and w must equal!")
  }
  Zi <- qnorm(1-p) 
  Z  <- sum(w*Zi)/sqrt(sum(w^2))
  p.val <- 1-pnorm(Z)
  return(c(p.value = p.val))
}
#http://en.wikipedia.org/wiki/Fisher%27s_method
Fisher.test <- function(p) {
  Xsq <- -2*sum(log(p))
  p.val <- 1-pchisq(Xsq, df = 2*length(p))
  return(c(p.value = p.val))
}

Stouffer <-c()
Fisher <-c()
for (i in 1:dim(PVALMATRIX)[1]) {

	Stouffer[i] <- Stouffer.test(p=PVALMATRIX[i,])[[1]]
	Fisher[i] <- Fisher.test(p=PVALMATRIX[i,])[[1]]
 

}

# Fisher's
 mcols(finalset) <- data.frame(IDR=idr.out$IDR, MM2, Stouffer.pvalue=Stouffer, Fisher.pvalue=Fisher)
 

###############################################################
 #centres
 finalsetcentres <- finalset

 start(finalsetcentres) <- round( (start(finalset) + end(finalset) )/2 )
 end(finalsetcentres)  <-  round( (start(finalset) + end(finalset) )/2 ) + 1

 if (bedfile==TRUE){
    export.bedGraph(object=finalset[passingIDR], con=paste("cexor_peak_events_IDR_",".bed", sep=as.character(idr)))
    export.bedGraph(object=finalsetcentres[passingIDR], con=paste("cexor_peak_centres_IDR_",".bed", sep=as.character(idr)))
 }

  return(list( bindingEvents=finalset[passingIDR], bindingCentres =finalsetcentres[passingIDR],  pairedPeaksRepl = repl ))

}

test_cexor <- function() {

	owd <- setwd(tempdir())

	rep1 <- "CTCF_rep1_chr2_1-1e6.bam"
	rep2 <- "CTCF_rep2_chr2_1-1e6.bam"
	rep3 <- "CTCF_rep3_chr2_1-1e6.bam"

	r1 <- system.file( "extdata", rep1, package="CexoR",mustWork = TRUE )
	r2 <- system.file( "extdata", rep2, package="CexoR",mustWork = TRUE )
	r3 <- system.file( "extdata", rep3, package="CexoR",mustWork = TRUE )
	
	out <- cexor( bam=c(r1,r2,r3), chrN="chr2", chrL=1e6, N=3e4, p=1e-12 )

	# check that the example data outputs a GRanges with 13 ranges 
    	checkEquals( length(out$bindingEvents), 13 )

    	# check that if minimal input is not introduced the package recognizes an error situation
	# bam
	checkException( cexor(bam=c(), chrN="chr2", chrL=1e6, N=3e4) )
	# chrN
	checkException( cexor(bam=c(r1,r2,r3), chrN=c(), chrL=1e6, N=3e4) )
	# chrL
	checkException( cexor(bam=c(r1,r2,r3), chrN="chr2", chrL=c(), N=3e4) )

	setwd(owd)
}

plotcexor <- function( bam, peaks, EXT=500 ){  
  
  N <- length(bam)
  colo <- colorRampPalette(brewer.pal(N,"Set2"))(N)
  
  # extend peak centre Upstream and Dowstream EXT bp
  peaks <- peaks$bindingCentres 
  start(peaks) <- start(peaks) - EXT
  end(peaks)   <- end(peaks)   + EXT
  # genomation
  nBins <- (2*EXT)+1
  scaleData <- FALSE
  # read bam
  sm <- list()
  smF <- list()
  smR <- list()
  for (j in seq(from=1, to=N, by=1) ){
    sm[[j]]  <- ScoreMatrixBin(target = bam[j], bin.num = nBins, windows = peaks, type="bam",strand.aware = TRUE, extend=0,rpm=F, param = ScanBamParam(which=reduce(peaks, ignore.strand=TRUE), flag=scanBamFlag(isMinusStrand=NA)))
    smF[[j]] <- ScoreMatrixBin(target = bam[j], bin.num = nBins, windows = peaks, type="bam",strand.aware = TRUE, extend=1,rpm=F, param = ScanBamParam(which=reduce(peaks, ignore.strand=TRUE), flag=scanBamFlag(isMinusStrand=FALSE)))
    smR[[j]] <- ScoreMatrixBin(target = bam[j], bin.num = nBins, windows = peaks, type="bam",strand.aware = TRUE, extend=1,rpm=F, param = ScanBamParam(which=reduce(peaks, ignore.strand=TRUE), flag=scanBamFlag(isMinusStrand=TRUE)))
  }

  # plot Ylim 
  YMAX <-0; YMAXF <-0; YMAXR <-0;
  for (j in 1:N){
    YMAX  <- max(YMAX, colMeans(sm[[j]],na.rm=TRUE) )
    YMAXF <- max(YMAXF, colMeans(smF[[j]],na.rm=TRUE) )
    YMAXR <- max(YMAXR, colMeans(smR[[j]],na.rm=TRUE) )
  }
  
  par(mfrow=c(2,1))
 
  L <- -EXT:EXT
  
  # upper panel
  for (j in seq(from=1, to=N, by=1) ){
    ym <- max(YMAXF,YMAXR)
    if (j==1){
      plot(L,colMeans(smF[[j]],na.rm=TRUE),type="l", col="red", lwd=1, frame.plot=F, xlab="Distance to \nbinding centre (bp)", ylab=expression(paste("Average ",lambda," exonuclease stop sites")), ylim=c(0,ym), lty=j)
      points(L,colMeans(smR[[j]],na.rm=TRUE),type="l", col="blue", lwd=1, lty=j) 
    }
    if (j!=1){
      points(L,colMeans(smF[[j]],na.rm=TRUE),type="l", col="red", lwd=1, lty=j) 
      points(L,colMeans(smR[[j]],na.rm=TRUE),type="l", col="blue", lwd=1, lty=j)   
    }
    
  }
  abline(v=0, lty=2)
  legend("topleft", text.col=c("red","blue"), legend=c("+ strand","- strand"), bty="n")
  legend("topright", col="black", legend=paste("rep", 1:N), lty=1:N, bty="n", lwd=1)
  
  # lower panel
  for (j in seq(from=1, to=N, by=1) ){
    if (j==1) plot(L,colMeans(sm[[j]],na.rm=TRUE),type="l", col=colo[j], lwd=2, frame.plot=F, xlab="Distance to \nbinding centre (bp)", ylab="Average ChIP-exo reads", ylim=c(0,YMAX))
    if (j!=1) points(L,colMeans(sm[[j]],na.rm=TRUE),type="l", col=colo[j], lwd=2)
  }
  abline(v=0, lty=2)
  legend("topright", col=colo, legend=paste("rep", 1:N), bty="n", lty=1, lwd=2)
  
}

#--------------------------------------------------------------------------
# pskellam.R and pskellam.sp.R within directory R/ are under GPL(≥2) license
#--------------------------------------------------------------------------
#    skellam: Skellam distribution. 
#
#    Copyright (C) 2009  Jerry W. Lewis
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.


pskellam.sp <- function(q, lambda1, lambda2=lambda1, lower.tail=TRUE, log.p=FALSE) {
 # Luganni-Rice saddlepoint CDF with Butler's 2nd continuity correction
    if (missing(q)|missing(lambda1)) stop("first 2 arguments are required")
    if (lower.tail) {
        xm <- -floor(q)-0.5                                     # continuity corrected x
       # distribution specific variables
        s <- log(0.5*(xm+sqrt(xm^2+4*lambda2*lambda1))/lambda2) # the saddlepoint
        K <- lambda2*(exp(s)-1)+lambda1*(exp(-s)-1)             # CGF(s)
        K2 <- lambda2*exp(s)+lambda1*exp(-s)                    # CGF''(s)
       # code depending on distribution only through previous variables
        u2 <- 2*sinh(0.5*s)*sqrt(K2)
        w2 <- sign(s)*sqrt(2*(s*xm-K))
        ret <- pnorm(-w2)-dnorm(w2)*(1/w2-1/u2)
       # avoid numeric problems near the removable discontinuity
        xe <- (xm+(lambda1-lambda2))/sqrt(lambda1+lambda2)
        g1 <- (lambda1-lambda2)/(lambda1+lambda2)^1.5
        ew <- abs(xe) < 1e-4
        ret[ew] <- (pnorm(-xe)+dnorm(xe)*g1/6*(1-xe^2))[ew]
    } else ret <- pskellam.sp(-q-1,lambda2,lambda1)
    if (log.p) log(ret) else ret
}

%\VignetteIndexEntry{ CexoR Vignette }
%\VignetteDepends{}
%\VignetteKeywords{Visualization,ChIPseq,Transcription,Genetics,Coverage,ChIPSeq}
%\VignettePackage{CexoR}
\documentclass{article}

<<style, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\begin{document}

\title{\Biocpkg{ CexoR }: An R package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates}
\date{Last Modified: October, 2021. Compiled: \today}
%\author{Pedro Madrigal\footnote{ pmadrigal@ebi.ac.uk }}
\author{Pedro Madrigal}

\maketitle

\begin{center}
EMBL-EBI, UK\\
\end{center}

\tableofcontents

<<setup, echo=FALSE, results=hide>>=
options(width=200)
options(continue=" ")
options(prompt="R> ")
@

\section{Citation}
Madrigal P (2015) CexoR: an R/Bioconductor package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates. \textbf{EMBnet.journal} 21, e837. 
\href{http://dx.doi.org/10.14806/ej.21.0.837}{http://dx.doi.org/10.14806/ej.21.0.837}.

\section{Introduction}
For its unprecedented level of resolution, chromatin immunoprecipitation combined with lambda exonuclease digestion followed by sequencing (ChIP-exo) is a potential candidate to replace ChIP-seq as the standard approach for high-confidence mapping of protein-DNA interactions. Numerous algorithms have been developed for peak calling in ChIP-seq data. However, adjusting the statistical models to ChIP-exo making use of its strand-specificity can improve
the identification of protein-DNA binding sites. The midpoint between the strand-specific paired peaks formed at its forward and reverse strands is delimited by the exonuclease stop sites, within the protein binding event is located (Rhee and Pugh, 2011).

\section{Methodology}
Lambda exonuclease stop site
(\Robject{5}' end of the reads) counts are calculated separately for both DNA strands from the alignment files in BAM format using the Bioconductor \Biocpkg{Rsamtools}. Counts are then normalized using linear scaling to the same sample depth of the smaller dataset. Using the Skellam distribution (Skellam, 1946), \Biocpkg{CexoR} models at each nucleotide position the discrete signed difference of two Poisson counts at forward and reverse strands, respectively. Then, detecting nearby located significant count differences of opposed sign (peak-pairs) at both strands allows \Biocpkg{CexoR} to delimit the flanks of the protein binding event location at base pair resolution. A one-sided $p$-value is obtained for each peak using the complementary cumulative Skellam distribution function, and a final $p$-value for the peak-pair (default cut-off $1e-12$) is reported as the sum of the two $p$-values. To account for the reproducibility of replicated peak-pairs, which central point must be located at a user-defined maximum distance, $p$-values are submitted for irreproducible discovery rate estimation (Li et al., 2011). Stouffer's and Fisher's combined p-values are given for the final peak-pair calls. Finally, BED files containing reproducible binding event locations formed within peak-pairs are reported, as well as their midpoints. 

More information can be found in Madrigal (2015).

\section{Example}
We downloaded the 3 replicates of human CTCF ChIP-exo data from GEO (SRA044886) (Rhee and Pugh, 2011), and aligned the reads to the human reference genome (hg19) using Bowtie 1.0.0. Reads not mapping uniquely were discarded. We can search reproducible binding events between peak-pairs in the first million bp of Chr2 in the 3 biological replicates by:

\begin{small}
<<Call reproducible peak-pairs in ChIP-exo replicates, eval=TRUE>>=
options(width=60)
## hg19. chr2:1-1,000,000

owd <- setwd(tempdir())

library(CexoR)
rep1 <- "CTCF_rep1_chr2_1-1e6.bam"
rep2 <- "CTCF_rep2_chr2_1-1e6.bam"
rep3 <- "CTCF_rep3_chr2_1-1e6.bam"
r1 <- system.file("extdata", rep1, package="CexoR",mustWork = TRUE)
r2 <- system.file("extdata", rep2, package="CexoR",mustWork = TRUE)
r3 <- system.file("extdata", rep3, package="CexoR",mustWork = TRUE)

peak_pairs <- cexor(bam=c(r1,r2,r3), chrN="chr2", chrL=1e6, idr=0.01, N=3e4, p=1e-12)

peak_pairs$bindingEvents

peak_pairs$bindingCentres

setwd(owd)

@ 
\end{small}

13 reproducible peak-pair events are reported for the established thresholds ($p$-value $\leq 1e-12$, IDR $\leq 0.01$). We can now plot the mean profile of lambda exonuclease stop sites and reads, 500 bp around the central position of reproducible peak-pair locations, by running the function "plotcexor": \\

\begin{small}
<<Visualisation of ChIP-exo replicates, fig.width=4.5, fig.height=9, eval=FALSE>>=
options(width=60)
plotcexor(bam=c(r1,r2,r3), peaks=peak_pairs, EXT=500)
@
\end{small}

\textbf{Important notes}: 
\begin{itemize}
\item For the correct estimation of the IDR (Li et al., 2011) peak-pair calling should be relaxed (e.g., $p$-value=1e-3, or smaller depending on the sequencing depth), enabling the noise component be present in the data and therefore allowing the peak-pairs to be separated into a reproducible and an irreproducible groups. In the example shown above, as the dataset is very small and peaks are highly reproducible, IDR in the overlapped peak-pairs across the 3 replicates is zero. 
\item IDR calculation could produce varying results depending on the choice of initial estimates for four parameters needed by the algorithm (mu, sigma, rho, prop). Li et al. (2011) recommend trying several choices, so that the parameter estimation does not get trapped in a local maximum.
\item For more information about using IDR in high-throughput sequencing datasets see Land et al. (2012) and Bailey et al. (2013), or the mathematical description in Li et al. (2011).

\end{itemize}

\section{References}
\begin{itemize}
\item Madrigal P (2015) CexoR: an R/Bioconductor package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates. \textbf{EMBnet.journal} 21: e837.
\item Bailey TL, et al. (2013). Practical Guidelines for the Comprehensive Analysis of ChIP-seq Data. \textbf{PLoS Comput Biol} 9: e1003326.
\item Landt SG, et al. (2012). ChIP-seq guidelines and practices of the ENCODE and modENCODE consortia. \textbf{Genome Res} 22: 1813-1831.  
\item Skellam JG (1946) The frequency distribution of the difference between two Poisson variates belonging to different populations. \textbf{J R Stat Soc Ser A} 109: 296.
\item Li Q, Brown J, Huang H, Bickel P (2011) Measuring reproducibility of high-throughput experiments. \textbf{Ann Appl Stat} 5: 1752-1779. 
\item Rhee HS, Pugh BF (2011) Comprehensive genome-wide protein-DNA interactions detected at single-nucleotide resolution. \textbf{Cell} 147: 1408-1419.
\end{itemize}

\section{References}
The author wishes to acknowledge Christoph Sebastian Borlin, Md. Abul Hassan Samee, Vivek Rexwal and Sudhir Jadhao for their feedback.

\section{Details}

This document was written using:

\begin{small}
<<sessionInfo>>=
sessionInfo()
@
\end{small} 

\end{document}

\name{plotcexor}
\alias{plotcexor}

\title{ Visualization of ChIP-exo peak-pair calling with replicates }
\description{ Visualization of ChIP-exo peak-pair calling with replicates. }

\usage{
  plotcexor(bam, peaks, EXT=500)
}

\arguments{
  \item{bam}{ BAM alignment files of biological replicates. }
  \item{peaks}{ Object (list) output of the function 'cexor'.}
  \item{EXT}{ Extension (bp) upstream and downstream the central position of reproducible peak pair locations for visulization purposes.}
}

\details{ Visualization of ChIP-exo peak-pair calling with replicates.}

\value{
  R plot.
}

\references{ Madrigal P (2015) CexoR: an R/Bioconductor package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates. EMBnet.journal  21: e837.  }

\author{ Pedro Madrigal, \email{pmadrigal@ebi.ac.uk} }

\seealso{ \code{\link{CexoR-package}} }

\examples{

  ## hg19. chr2:1-1,000,000. CTCF data from Rhee and Pugh (2011)
  owd <- setwd(tempdir())

  rep1 <- "CTCF_rep1_chr2_1-1e6.bam"
  rep2 <- "CTCF_rep2_chr2_1-1e6.bam"
  rep3 <- "CTCF_rep3_chr2_1-1e6.bam"
  r1 <- system.file("extdata", rep1, package="CexoR",mustWork = TRUE)
  r2 <- system.file("extdata", rep2, package="CexoR",mustWork = TRUE)
  r3 <- system.file("extdata", rep3, package="CexoR",mustWork = TRUE)

  chipexo <- cexor(bam=c(r1,r2,r3), chrN="chr2", chrL=1e6, idr=0.01, p=1e-12, N=3e4)

  plotcexor(bam=c(r1,r2,r3), peaks=chipexo, EXT=500)

  setwd(owd)

}

\name{cexor}
\alias{cexor}

\title{ ChIP-exo peak-pair calling with replicates}
\description{ ChIP-exo peak-pair calling with replicates. }

\usage{
cexor(bam, chrN, chrL, p=1e-9, dpeaks=c(0,150), dpairs=100, idr=0.01, 
N=5e6, bedfile=TRUE, mu=2.6, sigma=1.3, rho=0.8, prop=0.7)
}

\arguments{
  \item{bam}{ BAM alignment files of biological replicates. }
  \item{chrN}{ Vector of chromosome names. }
  \item{chrL}{ Vector of chromosome sizes (bp). }
  \item{p}{ P-value cutoff (should be relaxed, e.g. 1e-3, to allow the correct estimation of the irreproducible discovery rate (idr). However, this depends on the sequencing depth. For datasets with high number of tag counts, 1e-9 can be appropriate. See the vignette for more information.) }
  \item{dpeaks}{ Min. and max. allowed distance between peak pairs located at opposed strands in a replicate (bp). }
  \item{dpairs}{ Max. allowable distance between peak-pair centres across replicates (bp). }
  \item{idr}{ Irreproducible discovery rate cutoff [0-1]. }
  \item{N}{ Genome is divided in blocks of N bp. for processing. N must be not higher than the size of the smallest chromosome. }
  \item{bedfile}{ Generate BED files of ChIP-exo reproducible peak pairs.}
  \item{mu}{ A starting value for the mean of the reproducible component (see 'idr' package).}
  \item{sigma}{ A starting value for the standard deviation of the reproducible component (see 'idr' package).}
  \item{rho}{ A starting value for the correlation coefficient of the reproducible component (see 'idr' package).}
  \item{prop}{ A starting value for the proportion of reproducible component (see 'idr' package).}
  
}

\details{ Strand specific peak-pair calling in ChIP-exo replicates. The cumulative Skellam distribution function (package 'skellam') is used to detect significant normalized count differences of opposed sign at each DNA strand (peak-pairs). Irreproducible discovery rate for overlapping peak-pairs across biological replicates is estimated using the package 'idr'. 
The internal functions \code{pskellam} and \code{pskellam.sp} from the Jerry W. Lewis' 'skellam' R package (version 0.0-8-7) are used to calculate the cumulative Skellam distribution (see LICENSE file). }

\value{
  A list containing the following elements:
  \item{bindingEvents}{ A GRanges object with reproducible peak pair locations. The metadata 'value' indicates the Irreproducible discovery rate (IDR) estimated at this region, while 'repI.neg.log10pvalue' indicates -log10(p-value) for the replicate I. 'Stouffer.pvalue' and 'Fisher.pvalue' report the combined p-value considering they come from from independent significance tests. }
  \item{bindingCentres}{ A GRanges object with centre position of reproducible peak pair locations. The metadata 'value' indicates the Irreproducible discovery rate (IDR) estimated at this region, while 'repI.neg.log10pvalue' indicates -log10(p-value) for the replicate I. 'Stouffer.pvalue' and 'Fisher.pvalue' report the combined p-value considering they come from from independent significance tests.}
  \item{pairedPeaksRepl}{ A GRangesList object with the location of peak pairs retrieved at each replicate.  The metadata 'score' indicates -log10(p-value).}
}

\references{ Madrigal P (2015) CexoR: an R/Bioconductor package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates. EMBnet.journal  21: e837.  }

\author{ Pedro Madrigal, \email{pmadrigal@ebi.ac.uk} }

\seealso{ \code{\link{CexoR-package}} }

\examples{

  ## hg19. chr2:1-1,000,000. CTCF data from Rhee and Pugh (2011)
  owd <- setwd(tempdir())

  rep1 <- "CTCF_rep1_chr2_1-1e6.bam"
  rep2 <- "CTCF_rep2_chr2_1-1e6.bam"
  rep3 <- "CTCF_rep3_chr2_1-1e6.bam"
  r1 <- system.file("extdata", rep1, package="CexoR",mustWork = TRUE)
  r2 <- system.file("extdata", rep2, package="CexoR",mustWork = TRUE)
  r3 <- system.file("extdata", rep3, package="CexoR",mustWork = TRUE)

  chipexo <- cexor(bam=c(r1,r2,r3), chrN="chr2", chrL=1e6, idr=0.01, p=1e-12, N=3e4)

  plotcexor(bam=c(r1,r2,r3), peaks=chipexo, EXT=500)

  setwd(owd)

}

\name{CexoR-package}
\alias{CexoR-package}
\alias{CexoR}
\docType{package}

\title{ An R package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates }
\description{ Strand specific peak-pair calling in ChIP-exo replicates. The cumulative Skellam distribution function (package 'skellam') is used to detect significant normalised count differences of opposed sign at each DNA strand (peak-pairs). Irreproducible discovery rate for overlapping peak-pairs across biological replicates is estimated using the package 'idr'.}
\details{
    \tabular{ll}{
        Package: \tab CexoR\cr
        Type: \tab Package\cr
        Version: \tab 1.35.1\cr
        Date: \tab 2022-05-28\cr
        License: \tab Artistic-2.0 | GPL-2 + file LICENSE\cr
        LazyLoad: \tab yes\cr
    }
}

\author{
    Pedro Madrigal,

    Maintainer: Pedro Madrigal \email{pmadrigal@ebi.ac.uk}
}
\references{ Madrigal P (2015) CexoR: an R/Bioconductor package to uncover high-resolution protein-DNA interactions in ChIP-exo replicates. EMBnet.journal  21: e837. \cr 
Skellam JG (1946) The frequency distribution of the difference between two Poisson variates belonging to different populations. J R Stat Soc Ser A 109: 296. \cr 
Li Q, Brown J, Huang H, Bickel P (2011) Measuring reproducibility of high-throughput experiments. Ann Appl Stat 5: 1752-1779. \cr 
Rhee HS, Pugh BF (2011) Comprehensive genome-wide protein-DNA interactions detected at single-nucleotide resolution. Cell 147: 1408-1419. }

\examples{

    ## hg19. chr2:1-1,000,000. CTCF data from Rhee and Pugh (2011)
    owd <- setwd( tempdir() )

    rep1 <- "CTCF_rep1_chr2_1-1e6.bam"
    rep2 <- "CTCF_rep2_chr2_1-1e6.bam"
    rep3 <- "CTCF_rep3_chr2_1-1e6.bam"
    r1 <- system.file( "extdata", rep1, package="CexoR",mustWork = TRUE )
    r2 <- system.file( "extdata", rep2, package="CexoR",mustWork = TRUE )
    r3 <- system.file( "extdata", rep3, package="CexoR",mustWork = TRUE )

    chipexo <- cexor( bam=c(r1,r2,r3), chrN="chr2", chrL=1e6, idr=0.01, p=1e-12, N=3e4 )

    plotcexor( bam=c(r1,r2,r3), peaks=chipexo, EXT=500 )

    setwd( owd )
}
